using System;
using System.Windows.Forms;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace StyledControls
{
	public class StyledListBox : ListBox
	{
		public StyledListBox()
		{
			SetStyle(ControlStyles.UserPaint, true);
		}

		protected override void OnMeasureItem(MeasureItemEventArgs e)
		{
			base.OnMeasureItem(e);

			e.ItemHeight = 24;
			e.ItemWidth = Width;
		}

		protected override void OnDrawItem(DrawItemEventArgs e)
		{
			base.OnDrawItem(e);

			e.Graphics.FillRectangle(Brushes.Red, e.Bounds);
			e.Graphics.DrawString(Items[e.Index].ToString(), e.Font, Brushes.Green, e.Bounds);
		}
	}
}
